package com.persagy.dmp.admin.service;

import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.node.ArrayNode;
import com.fasterxml.jackson.databind.node.JsonNodeFactory;
import com.fasterxml.jackson.databind.node.ObjectNode;
import com.persagy.common.json.JacksonMapper;
import com.persagy.dmp.admin.service.trans.GraphMapping;
import com.persagy.dmp.common.http.HttpUtils;
import com.persagy.dmp.rwd.model.RelationInstanceModel;
import org.junit.Test;

import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

/**
 * @author: yaoll
 * @date: 2021-01-05
 * @verison: 1.0
 */
public class TestGraph {


	@Test
	public void test1() {
		String graphId = "GtSubset001";
		System.out.println(graphId.substring(2, graphId.length() -3));
	}


	@Test
	public void test2() throws Exception {

		String file = "/Users/devsaga/workspace/sublime/relation.txt";
		PrintWriter writer = new PrintWriter(new OutputStreamWriter(new FileOutputStream(file)));
		String graphId = "GtSubset001";
		HttpUtils httpUtils = new HttpUtils();
		String url = "http://39.97.179.199:8888/data-platform-3/relation/query?projectId=Pj1101050029&secret=saga123456";
		String requestBody = "{\"criteria\":{\"graph_id\":\"" + graphId + "\"}}";
		HttpUtils.HttpResult post = httpUtils.post(url, requestBody, 300 * 1000);

		String content = post.getContent();
		ObjectNode objectNode = JacksonMapper.toObject(content, ObjectNode.class);

		ArrayNode array = JacksonMapper.getArray(objectNode, "Content", JsonNodeFactory.instance.arrayNode());
		List<RelationInstanceModel> relationInstanceModelList = new ArrayList<>();
		Set<String> errors = new HashSet<>();
		int i = 0;
		for (JsonNode jsonNode : array) {
			ObjectNode item = (ObjectNode) jsonNode;
			String relType = JacksonMapper.getString(item, "rel_type");
			String objFrom = JacksonMapper.getString(item, "from_id");
			String objTo = JacksonMapper.getString(item, "to_id");

			String graphCode = graphId.substring(2, graphId.length() - 3);
			GraphMapping.Item mapping = GraphMapping.getMapping(graphCode, relType);
			if (mapping == null) {
				errors.add(graphCode + "-" + relType);
			}
			writer.println(jsonNode.toString());
			if (i % 1000 == 0) {
				writer.flush();
			}
		}
		writer.flush();
		writer.close();
		for (String error : errors) {
			System.out.println(error);
		}

	}
}
